<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use ACL\Services\UserTrigger as UserTriggerService;

class UserTrigger {

    use TResponse;

    /**
     * @var UserTriggerService
     */
    private $userTriggerService;

    public function __construct(UserTriggerService $userTriggerService)
    {
        $this->userTriggerService = $userTriggerService;
    }

    public function findAllUserTrigger(Request $request, Response $response)
    {
        try {
            $data = $this->userTriggerService->findAllUserTrigger();
            $this->sendResponse($data, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function updateSituationTrigger(Request $request)
    {
        try{
            $dataset = $request->getParameters();
            $this->userTriggerService->updateSituationTrigger($dataset);
            $this->sendResponse(null, 204);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
