<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Filial as FilialRepository;
use ACL\Traits\TCrud;
use ACL\Util\AclUtilities;
use ACL\Util\Messages;
use Exception;
use Teknisa\Libs\Util\Utilities as LibUtilities;

class Filial {

    use TCrud;

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var FilialRepository
     */
    private $filialRepository;


    public function __construct(FilialRepository $filialRepository)
    {
        $this->filialRepository = $filialRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    /**
     * @param null $isFilterNotInFilial
     * @param null $cdoperador
     * @return array
     */
    public function findFilial($isFilterNotInFilial = null, $cdoperador= null): array
    {
        return $this->filialRepository->findFilial(getNrorg(), $isFilterNotInFilial, $cdoperador);
    }


}
