<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Filioper as FilioperRepository;
use Exception;
use Teknisa\Libs\Util\Environment;

class Filioper
{

    /**
     * @var Environment
     */
    private $libEnvironment;

    /**
     * @var FilioperRepository
     */
    private $filioperRepository;

    public function __construct(FilioperRepository $filioperRepository)
    {
        $this->filioperRepository = $filioperRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    public function findFilioper($cdoperador): array
    {
        $filters = "AND CDOPERADOR = '{$cdoperador}'";
        return $this->filioperRepository->findFilioper(getNrorg(), $filters);
    }

    /**
     * @param $dataset
     * @throws Exception|\Doctrine\DBAL\Driver\Exception
     *
     */
    public function createFilioper($dataset)
    {
        foreach ($dataset as $row) {
            $this->filioperRepository->create(
                $row['CDOPERADOR'], $row['CDFILIAL'], getNrorg(), getCurrentUserId(), $row['DTVALIDADE']
            );
        }
    }

    /**
     * @param $dataset
     * @throws \Doctrine\DBAL\Driver\Exception
     */
    public function updateFilioper($dataset)
    {
        foreach ($dataset as $row) {
            $this->filioperRepository->updateFilioper(
                $row['CDOPERADOR'], $row['CDFILIAL'], getNrorg(), $row['DTVALIDADE'], $row['IDATIVO']
            );
        }
    }

    /**
     * @param $dataset
     * @throws \Doctrine\DBAL\Driver\Exception
     */
    public function deleteFilioper($dataset)
    {
        foreach ($dataset as $row) {
            $this->filioperRepository->deleteFilioper($row['CDOPERADOR'], $row['CDFILIAL'], getNrorg());
        }
    }
}
