<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Paramgeral as ParamgeralRepository;
use ACL\Traits\TCrud;
use Doctrine\DBAL\Driver\Exception;

class Paramgeral
{

    use TCrud;

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var ParamgeralRepository
     */
    private $paramgeralRepository;

    public function __construct(ParamgeralRepository $paramgeralRepository)
    {
        $this->paramgeralRepository = $paramgeralRepository;
        $this->libEnvironment = InstanceProvider::getLibEnvironment();
    }

    /**
     * @return array
     */
   public function findParamgeral(): array
   {
       return $this->paramgeralRepository->findParamgeral(getNrorg());
   }

    /**
     * @param $idutctrlacesweb
     * @return string[]
     * @throws Exception
     * @throws \Exception
     */
   public function changeAccessControl($idutctrlacesweb): array
   {
       $accessControllUtilization = InstanceProvider::getService()->getPerfilacesso()->findAccessControlUtilization();
       $accessControlValue = $idutctrlacesweb == 'N' ? 'S' : 'N';

       if(!empty($accessControllUtilization)) {
           $this->paramgeralRepository->updateParamgeralByAccessControl($accessControlValue, getNrorg());
       } else {
           $interval = 1;
           $colSize = 4;
           $cdparamgeral = InstanceProvider::getNewCode()->getCodeByTableName('PARAMGERAL', getNrorg(), $interval, $colSize);
           $this->paramgeralRepository->createParamgeralByAccessControl($accessControlValue, $cdparamgeral, getNrorg());
       }

       return array('idutctrlacesweb' => $accessControlValue);
   }
}
